

function   [Z, ERR]    =    AMT2(Y,Params)

Masks2      =       getGlobalMasks;
X_Vdeo      =       getGlobalX_Vdeo;
NormX       =       getGlobalNormX;

Afull 	    =	  @(I) fft2(conj(Masks2).*reshape(repmat(I,[1,Params.L]), Params.n_1, Params.n_2, Params.L, Params.q));
Afull_t     =	  @(E) sum(sum( Masks2 .* ifft2(E), 3) , 4)* Params.n_1 * Params.n_2; %* size(E,3);
Afull_tk    =	  @(S) sum( Masks2 .* ifft2(S), 3)*Params.n_1*Params.n_2;

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Iitialization

[~,~, ~,Z]  =     alt_min_init(Y, Params, Afull, Afull_t, Afull_tk);

%%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Main loop

 Rel_Err    =   zeros(Params.q, Params.T);
 
for     t   =         1   :     Params.T
    
    fprintf('AMT 2Iteration # %d of main loop...\n', t);
    for    aa     =   1      :  Params.q
        Masks     =   Masks2(:,:,:,aa);
        A         =   @(I)  fft2(conj(Masks) .* reshape(repmat(I, [1 Params.L]), size(I, 1), size(I, 2), Params.L));
        At        =   @(W) sum(Masks .* ifft2(W), 3) * size(W, 1) * size(W, 2);              
        grad      =  compute_grad2(Z(:,:,aa), Y(:,:,:,aa), Params, A, At);
        Z(:,:,aa) =  Z(:,:,aa)- Params.mu * grad;
    end
    Xhat          =   reshape(Z,Params.n,Params.q);
    [UE,~,~,~]    =   BlockIter(Xhat,Params.MaxIter,Params.r);
    DD            =   UE*(UE'*Xhat);
    Z             =   reshape(DD,Params.n_1,Params.n_2,Params.q);
    
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    %  Calculating Error
    
    Tmp_Err_X         =     zeros(Params.q,1);
         for   na     =     1   :   Params.q
            xa_hat    =     Z(:,:,na);
            xa        =     X_Vdeo(:,:,na);
            Tmp_Err_X(na) 	=    norm(xa - exp(-1i*angle(trace(xa'*xa_hat))) * xa_hat, 'fro')^2;
         end
    Rel_Err(:,t)     =      Tmp_Err_X;
         
    %%%   fprintf('TWF Projection Error is:\t%2.2e\n',ERR(:,t));
    
end     
ERR         =       sum(Rel_Err)/NormX;


