

clc;
clear;
close all;

%       Parameters Setting
ImRszFac    =   0.1;

%   Reading the video
obVdeo      =   VideoReader('sara.mp4');
q           =   0;

while hasFrame(obVdeo)
    q       =   q + 1;
    video   =   readFrame(obVdeo);
    video   =   rgb2gray(video);
    video   =   double(video);
    video   =   imresize(video,ImRszFac);
    n_1     =   size(video,1);
    n_2     =   size(video,2);
    X_Vdeo_mat(:,q) = reshape(video,[n_1*n_2,1]);
    fprintf('Frame # %d has been read...\n', q);
end

X_Vdeoval      =   reshape(X_Vdeo_mat,n_1,n_2,q);
setGlobalX_Vdeo(X_Vdeoval);
X_Vdeo      =   getGlobalX_Vdeo;

Den_X_Vdeo  =   norm(X_Vdeo_mat,'fro');
setGlobalNormX(Den_X_Vdeo)

%   Parameters Setting
MaxIter     =   50;
L           =   1;
alpha_y     =   3;
r           =   5;
itr_num_pow_mth    =    50;
n           =   n_1 * n_2;
m           =   n * L;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Parameters of AMT
ParamsAMT.n        =   n;
ParamsAMT.n_1      =   n_1;
ParamsAMT.n_2      =   n_2;
ParamsAMT.r        =   r;
ParamsAMT.q        =   q;
ParamsAMT.L        =   L;
ParamsAMT.alpha_y  =   3;
ParamsAMT.itr_num_pow_mth    =    itr_num_pow_mth;
ParamsAMT.m        =   n_1*n_2*L;
ParamsAMT.T_altmin =   50;
ParamsAMT.MaxIter  =  MaxIter;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%   Parameters of AMT2
ParamsAMT2.MaxIter  =  MaxIter;
ParamsAMT2.itr_num_pow_mth    =    itr_num_pow_mth;
ParamsAMT2.n     =   n;
ParamsAMT2.n_1   =   n_1;
ParamsAMT2.n_2   =   n_2;
ParamsAMT2.n1    =   n_1;
ParamsAMT2.n2    =   n_2;
ParamsAMT2.cplx_flag   = 0;
ParamsAMT2.alpha_lb    = 0.3;
ParamsAMT2.alpha_ub    = 5;
ParamsAMT2.alpha_h     = 5;
ParamsAMT2.alpha_y     = 3;
ParamsAMT2.T           = 50;	% number of iterations
ParamsAMT2.mu          = 0.2;	% step size / learning parameter
ParamsAMT2.npower_iter = itr_num_pow_mth;	% number of power iterations
ParamsAMT2.grad_type   = 'TWF_Poiss';
ParamsAMT2.alpha       = q;
ParamsAMT2.q           = q;
ParamsAMT2.r           = r;
ParamsAMT2.L           = L;
ParamsAMT2.m           = m;

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
Paramstwf.n     =   n;
Paramstwf.n1    =   n_1;
Paramstwf.n2    =   n_2;
Paramstwf.cplx_flag   = 0;
Paramstwf.alpha_lb    = 0.3;
Paramstwf.alpha_ub    = 5;
Paramstwf.alpha_h     = 5;
Paramstwf.alpha_y     = 3;
Paramstwf.T           = 50;	% number of iterations
Paramstwf.mu          = 0.2;	% step size / learning parameter
Paramstwf.npower_iter = itr_num_pow_mth;	% number of power iterations
Paramstwf.grad_type   = 'TWF_Poiss';
Paramstwf.alpha       = q;
Paramstwf.q           = q;
Paramstwf.r           = r;
Paramstwf.L           = L;
Paramstwf.m           = m;
Paramstwf.MaxIter     = MaxIter;
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%//////////////////////////////////////////////////
%  Generating Masks
%profile on
TmpMask    =    zeros(n_1*n_2,q,L);

for nl = 1 : L
    TmpMask(:,:,nl) 	=   randsrc(n_1*n_2, q, [1,-1,1i,-1i]);
end

Masksval    =         reshape(TmpMask, n_1,n_2,L,q);

setGlobalMasks(Masksval);
Masks       =         getGlobalMasks;    %---->Defining Masks as a global variable
%/////////////////////////////////////////////////
%  Defining functions

Afull 	 =	@(I) fft2(conj(Masks).*reshape(repmat(I,[1,L]), n_1, n_2, L, q));

%/////////////////////////////////////////////////
% Generating measurements

Y       =   abs(Afull(X_Vdeo)).^2;

%////////////////////////////////////////////////
%           Calling the functions
%       AMT2
[X_Vdeo_AMT2, ERRAMT2iter]       =    AMT2(Y,ParamsAMT2);

%       AMT
[X_Vdeo_AMT, ERRAMTiter]         =   alt_min_phs_rtv_2D(Y, ParamsAMT);

%       TWFProj
[X_Vdeo_TWFPrj, ERRTWFPrjiter]   =   TWFProj2D(Y, Paramstwf);

%       TWF
[X_Vdeo_TWF, ERRTWFiter]         =   TWF2D(Y, Paramstwf);

  

%   Writing to the files and computing the errors
vdo_out_obj_amt2    =   VideoWriter('AMT2_PlaneOrigR25L1');
vdo_out_obj_amt     =   VideoWriter('AMT_PlaneOrigR25L1');
vdo_out_obj_twf     =   VideoWriter('TWF_PlaneOrigR25L1');
vdo_out_obj_twfprj  =   VideoWriter('TWFPrj_PlaneOrigR25L1');

open(vdo_out_obj_amt2);
open(vdo_out_obj_amt);
open(vdo_out_obj_twf);
open(vdo_out_obj_twfprj);

Tmp_Err_AMT2    =   zeros(q, 1);
Tmp_Err_AMT     =   zeros(q, 1);
Tmp_Err_TWF     =   zeros(q, 1);
Tmp_Err_TWFPrj  =   zeros(q, 1);

X_Vdeo_mat_AMT2 =   reshape(X_Vdeo_AMT2,n,q);
X_Vdeo_mat_AMT  =   reshape(X_Vdeo_AMT,n,q);
X_Vdeo_mat_TWF  =   reshape(X_Vdeo_TWF,n,q);
X_Vdeo_mat_TWFPr=   reshape(X_Vdeo_TWFPrj,n,q);

for   t    =  1  :   q

    writeVideo(vdo_out_obj_amt2, uint8(abs(X_Vdeo_AMT2(:,:,t))));
    writeVideo(vdo_out_obj_amt, uint8(abs(X_Vdeo_AMT(:,:,t))));
    writeVideo(vdo_out_obj_twf, uint8(abs(X_Vdeo_TWF(:,:,t))));
    writeVideo(vdo_out_obj_twfprj, uint8(abs(X_Vdeo_TWFPrj(:,:,t))));

    xa_hat_amt2     =   X_Vdeo_mat_AMT2(:,t);
    xa_hat_amt      =   X_Vdeo_mat_AMT(:,t);
    xa_hat_twf      =   X_Vdeo_mat_TWF(:,t);
    xa_hat_twfprj   =   X_Vdeo_mat_TWFPr(:,t);

    xa              =   X_Vdeo_mat(:,t);

    Tmp_Err_AMT2(t)  =   norm(xa - exp(-1i*angle(trace(xa'*xa_hat_amt2))) * xa_hat_amt2, 'fro');
    Tmp_Err_AMT(t)   =   norm(xa - exp(-1i*angle(trace(xa'*xa_hat_amt))) * xa_hat_amt, 'fro');
    Tmp_Err_TWF(t)   =   norm(xa - exp(-1i*angle(trace(xa'*xa_hat_twf))) * xa_hat_twf, 'fro');
    Tmp_Err_TWFPrj(t)=   norm(xa - exp(-1i*angle(trace(xa'*xa_hat_twfprj))) * xa_hat_twfprj, 'fro');

end

close(vdo_out_obj_amt2);
close(vdo_out_obj_amt);
close(vdo_out_obj_twf);
close(vdo_out_obj_twfprj);

Nom_Err_X_AMT2	    =   sum(Tmp_Err_AMT2);
Nom_Err_X_AMT 	    =   sum(Tmp_Err_AMT);
Nom_Err_X_TWF 	    =   sum(Tmp_Err_TWF);
Nom_Err_X_TWFPrj    =   sum(Tmp_Err_TWFPrj);

Err_X_AMT2          =   Nom_Err_X_AMT2   / Den_X_Vdeo;
Err_X_AMT           =   Nom_Err_X_AMT    / Den_X_Vdeo;
Err_X_TWF           =   Nom_Err_X_TWF    / Den_X_Vdeo;
Err_X_TWFPrj        =   Nom_Err_X_TWFPrj / Den_X_Vdeo;

semilogy(ERRAMT2iter);
%save('ErroAMT2Iter.mat','ERRAMT2iter');
hold on;
semilogy(ERRAMTiter);
%save('ErroAMTIter.mat','ERRAMTiter');
hold on;
semilogy(ERRTWFPrjiter);
%save('ErroTWFPrjIter.mat','ERRTWFPrjiter');
hold on;
semilogy(ERRTWFiter);
%save('ErroTWFIter.mat','ERRTWFiter');
hold on;

legend('AMT2','AMT','TWFPrj','TWF');
grid on;

